#!/usr/bin/env python
import sys
dirs=['up','right','down','left']

class Eval(object):
    def __init__(self,prog):
        self.prog=prog
        self.regs={'a':0,'b':0,'c':0,'d':0,'e':0,'f':0,'g':0,'h':0,'pc':0}
        self.mem=[0]*256
        self.lcoords=(50,25)
        self.gscoords=[(25,25),(0,0),(0,0),(0,0)]
        self.gcoords=[(25,25),(0,0),(0,0),(0,0)]
        self.myindex=0
        self.world = None
        
    def get(self,arg):
        arg=str(arg)
        indirect=arg[0]=="[" 
        if indirect:
            arg=arg[1:-1]
        if arg in self.regs.keys():
            if indirect:
                if arg=="pc":
                    raise Exception("can't deref pc")
                return int(self.mem[self.regs[arg]])
            else:
                return int(self.regs[arg])
        else:
            arg=int(arg)
            if indirect:
                return int(self.mem[arg])
            else:
                return int(arg)
    
    def set(self,arg,val):
        arg=str(arg)
        indirect=arg[0]=="[" 
        if indirect:
            arg=arg[1:-1]
        if arg in self.regs.keys():
            if indirect:
                if arg=="pc":
                    raise Exception("can't deref pc")
                self.mem[self.regs[arg]]=int(val)
            else:
                self.regs[arg]=int(val)
        else:
            arg=int(arg)
            if indirect:
                self.mem[arg]=int(val)
            else:
                raise Exception("can't assign to constant")
    
    def run(self):
        self.regs['pc']=0
        while (1):
            print "next command: %s"%prog[self.regs['pc']]
            command=prog[self.regs['pc']]
            command=command.split(";")[0]
            opcode=command.split()[0]
            try:
                args=command[command.index(" "):]
                args=args.split(',')
                args=map(lambda x:x.strip(),args)
            except:
                args=[]
            lastpc=self.regs['pc']
            r=self.regs.keys()
            r.sort()
            rs=''
            for i in r:
                rs+=i+": " +`self.regs[i]`+" "
            print "regs: %s"%rs
            print "memory: %s"%self.mem[:16]
            for i in range(16):
                ms=""
                for j in self.mem[i*16:i*16+16]:
                        ms+=`j`.rjust(4)
                print ms
            #raw_input()
            if opcode =="mov":
                self.set(args[0],self.get(args[1]))
            elif opcode == "inc":
                val=self.get(args[0])+1
                self.set(args[0],(val) % 256)
            elif opcode == "dec":
                self.set(args[0],(self.get(args[0])-1) % 256)
            elif opcode == "add":
                self.set(args[0],(self.get(args[0])+self.get(args[1]))%256)
            elif opcode == "sub":
                self.set(args[0],(self.get(args[0])-self.get(args[1]))%256)            
            elif opcode == "mul":
                self.set(args[0],(self.get(args[0])*self.get(args[1]))%256)            
            elif opcode == "div":
                self.set(args[0],(self.get(args[0])/self.get(args[1]))%256)            
            elif opcode == "and":
                self.set(args[0],(self.get(args[0])&self.get(args[1]))%256)            
            elif opcode == "or":
                self.set(args[0],(self.get(args[0])|self.get(args[1]))%256)            
            elif opcode == "xor":
                self.set(args[0],(self.get(args[0])^self.get(args[1]))%256)            
            elif opcode == "jlt":
                if (self.get(args[1])<self.get(args[2])):
                    self.set("pc",self.get(args[0]))
            elif opcode == "jeq":
                if (self.get(args[1])==self.get(args[2])):
                    self.set("pc",self.get(args[0]))
            elif opcode == "jgt":
                if (self.get(args[1])>self.get(args[2])):
                    self.set("pc",self.get(args[0]))
            elif opcode == "int":
                intno=int(args[0])
                if intno==0:
                    print "##################################"
                    print "New direction %s (%s)"%(self.get('a'),dirs[self.get('a')])
                elif intno==1:
                    self.set('a',self.lcoords[0])
                    self.set('b',self.lcoords[1])
                elif intno==2:
                    pass
                elif intno==3:
                    self.set('a',self.myindex)
                    
                elif intno==4:
                    ind=self.get('a')
                    self.set('a',self.gscoords[ind][0])
                    self.set('b',self.gscoords[ind][1])
                elif intno==5:
                    ind=self.get('a')
                    self.set('a',self.gcoords[ind][0])
                    self.set('b',self.gcoords[ind][1])
                elif intno==6:
                    self.set('a',0)
                    self.set('b',0)
                elif intno==7:
                    self.set('a',1)
                    self.set('b',1)
                elif intno==8:
                    print regs
                else:
                    raise Exception("Illegal int %s"%intno)
            elif opcode == "hlt":
                print"completed"
                return 
            else:
                raise Exception("illegal opcode %s"%opcode)
            if (self.regs['pc']==lastpc):
                self.regs['pc']+=1
            
if (__name__=='__main__'):
    prog=file(sys.argv[1]).read().lower().split("\n")
    myeval=Eval(prog)
    myeval.run()